//+------------------------------------------------------------------+
//|                                        FxCraft Mlot/Wisielec.mq4 |
//|                                              http://fxcraft.biz/ |
//|                                                           v. 1.1 |
//+------------------------------------------------------------------+
//|                                                                  |
//| Licence is available at:                                         |
//| http://fxcraft.biz/licence_free_indicator                        |
//| Licencja jest dostpna pod adresem:                              |
//| http://fxcraft.biz/licencja_darmowy_wskaznik                     |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 LawnGreen
#property indicator_color2 OrangeRed

double mlot[];  //mlot+
double wisi[];  //wisielec-

extern double lower_shadow = 65;
extern int length = 100;
extern int checkPrevious = 3;
extern int trendMethod = 0;

double nadpod;

int init()
{
   SetIndexBuffer(0,mlot);
   SetIndexStyle(0,DRAW_ARROW,0,1);
   SetIndexArrow(0,236);
   SetIndexEmptyValue(0,0);
   
   SetIndexBuffer(1,wisi);
   SetIndexStyle(1,DRAW_ARROW,0,1);
   SetIndexArrow(1,238);
   SetIndexEmptyValue(1,0);
   
   nadpod = MathSqrt(Period()*1.0)*Point;
   
   return(0);
}
int deinit()
{
   return(0);
}
int start()
{     
   int  i, counted_bars = IndicatorCounted();
   
   if(counted_bars<0) 
      return(-1);
   
   i = Bars-counted_bars-1;
      
   while(i>0)
   {
      bool jestmlot = false;
      bool jestwisi = false;
                   
      mlot[i] = 0;
      wisi[i] = 0;
      
      RefreshRates();
      
      if(High[i]-Low[i] >= length*Point)
      {        
         if( Open[i] - Low[i] > 0.01*lower_shadow*(High[i] - Low[i]) && Close[i] - Low[i] > 0.01*lower_shadow*(High[i]-Low[i]) )
         {
            if(checkPrevious > 0 && Bars > i + checkPrevious + 1)
            {
               if( iLowest(Symbol(),Period(),MODE_LOW ,checkPrevious+1,i) == i && trend(i,trendMethod,OP_SELL))
               {
                  jestmlot = true;
               }
               if(iHighest(Symbol(),Period(),MODE_HIGH,checkPrevious+1,i) == i && trend(i,trendMethod,OP_BUY ))
               {
                  jestwisi = true;
               }
               if(jestmlot && jestwisi)
               {
                  jestmlot = false;
                  jestwisi = false;
               }
            }
            else
            {
               jestmlot = true;
               jestwisi = true;
            }
         }
      }
      
      if(jestmlot)
         mlot[i] = Low[i]  - nadpod;
      if(jestwisi)
         wisi[i] = High[i] + nadpod;
                  
      i--;
   }
   
   return(0);
}
//+------------------------------------------------------------------+

bool trend(int i, int mode, int jaki)
{
   switch(mode)
   {
      case 0:
         return (true);
      case 1:
         double up[3];
         double dn[3];
         int licznikUP = 0;
         int licznikDN = 0;
         
         int j = i;
         while(Bars > j && (licznikUP < 3 || licznikDN < 3))
         {   
            double upp = iFractals(Symbol(),Period(),MODE_UPPER,j);
            double low = iFractals(Symbol(),Period(),MODE_LOWER,j);
            
            if(upp > 0 && licznikUP < 3)
            {
               up[licznikUP] = upp;
               licznikUP++;
            }
            if(low > 0 && licznikDN < 3)
            {
               dn[licznikDN] = low;
               licznikDN++;
            }

            j++;
         }
         
         if(licznikUP == 3 && licznikDN == 3)
         {
            if      (up[0] > up[1] && up[1] > up[2] && dn[0] > dn[1] && dn[1] > dn[2] && jaki == OP_BUY ) 
               return(true);
            else if (up[0] < up[1] && up[1] < up[2] && dn[0] < dn[1] && dn[1] < dn[2] && jaki == OP_SELL) 
               return(true);
         }     
   }
   
   return(false);
}